洛谷 4847 银河英雄传说 V2

我们先看看原题的做法,dsu 边带权对吧。
再看这道题。序列?平衡树!

仔细观察这几个操作,发现不是 Splay 和 FHQ Treap 的常规操作。
如果实现需要一些奇怪的处理。
算一算复杂度是对的。

M 操作,就直接按照维护序列的方式把 \(y\) 所在序列合并到 \(x\) 所在序列中。
D 操作,让我们想到分裂操作,但是它给出的是结点编号而非排名,所以可以写一个函数求一下某结点的排名。
Q 操作,配合求结点排名的操作就很容易了,然后注意区间不一定 \(l \le r\)

这些操作因为没有直接给定根节点,Splay 的话就直接 Splay 一下,FHQ Treap 就得找根。
这又让我们联想到并查集,但是很不幸的是,由于第二个操作,不能路径压缩。
不过,由于平衡树本来的期望树高就是 \(\log{n}\) 的,复杂度有保障。

然后不开 O2 也只要 500+ms,比较稳,
听说还有 Splay 跑不进一秒的……

代码:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#define ls(p) tree[p].lson
#define rs(p) tree[p].rson
using namespace std;
const int N = 2e5;
int n,m;
struct node
{
long long val,sum;
int rnd,sz;
int lson,rson,fa;
} tree[N + 10];
inline int get(int p)
{
return tree[p].fa == p ? p : get(tree[p].fa);
}
inline void up(int p)
{
tree[p].sz = tree[ls(p)].sz + 1 + tree[rs(p)].sz;
tree[p].sum = tree[ls(p)].sum + tree[p].val + tree[rs(p)].sum;
if(ls(p))
tree[ls(p)].fa = p;
if(rs(p))
tree[rs(p)].fa = p;
}
void split(int p,int k,int &x,int &y)
{
if(!p)
{
x = y = 0;
return ;
}
if(tree[ls(p)].sz < k)
x = p,split(rs(p),k - tree[ls(p)].sz - 1,rs(p),y);
else
y = p,split(ls(p),k,x,ls(p));
tree[x].fa = x,tree[y].fa = y;
up(p);
}
int merge(int x,int y)
{
if(!x || !y)
return x | y;
if(tree[x].rnd < tree[y].rnd)
{
rs(x) = merge(rs(x),y);
up(x);
return x;
}
else
{
ls(y) = merge(x,ls(y));
up(y);
return y;
}
}
int getrank(int p)
{
int ret = tree[ls(p)].sz + 1;
while(tree[p].fa ^ p)
{
if(rs(tree[p].fa) == p)
ret += tree[ls(tree[p].fa)].sz + 1;
p = tree[p].fa;
}
return ret;
}
int main()
{
scanf("%d%d",&n,&m);
for(register int i = 1;i <= n;++i)
scanf("%lld",&tree[i].val),tree[i].sum = tree[i].val,tree[i].rnd = rand(),tree[i].sz = 1,tree[i].fa = i;
char op;
int a,b;
while(m--)
{
scanf(" %c",&op);
if(op == 'M')
{
scanf("%d%d",&a,&b);
int fa = get(a),fb = get(b);
if(fa ^ fb)
merge(fb,fa);
}
else if(op == 'D')
{
scanf("%d",&a);
int fa = get(a),x,y;
split(fa,getrank(a) - 1,x,y);
}
else
{
scanf("%d%d",&a,&b);
if(get(a) ^ get(b))
puts("-1");
else
{
int fa = get(a);
int l = getrank(a),r = getrank(b);
int x,y,z;
split(fa,r,x,z);
split(x,l - 1,x,y);
printf("%lld\n",tree[y].sum);
fa = merge(merge(x,y),z);
}
}
}
}